"use strict";
{
    const C3 = self.C3;

    C3.Plugins.EMI_INDO_CheckInternetAccess.Instance = class CheckInternetAccessInstance extends C3.SDKInstanceBase
    {
        constructor(inst, properties)
        {
            super(inst);


            if (properties)
            {}



            const self = this;

            this.CallBack = C3.Plugins.EMI_INDO_CheckInternetAccess.Cnds;

            this._internetAccess = false;
            this._errorMessage = "";

            return this.updateOnlineStatusWithFetch();




        }

        Release()
        {
            super.Release();
        }

        SaveToJson()
        {
            return {
                // data to be saved for savegames
            };
        }

        LoadFromJson(o)
        {
            // load state for savegames
        }


        async checkInternetAccess()
        {
            try
            {
                const response = await fetch('https://www.google.com',
                {
                    mode: 'no-cors'
                });
                return response.type === 'opaque';
            }
            catch (error)
            {
                return false;
            }
        }

        updateOnlineStatusWithFetch()
        {
            const self = this;

            this.checkInternetAccess()
                .then(hasInternetAccess => {
                if (hasInternetAccess)
                {
                    console.log("You have internet access!", JSON.stringify(hasInternetAccess));

                    self._internetAccess = (hasInternetAccess);
                    self.Trigger(self.CallBack.Online);
                }
                else
                {
                    console.log("You are offline or cannot reach the internet!");
                    self.Trigger(self.CallBack.Offline);
                }
            })
                .
            catch (error => {
                console.error("An error occurred while checking internet access:", error);
                self._errorMessage = (error);
                self.Trigger(self.CallBack.Error);
            });
        }






        SetStatus(_index)
        {
            switch (_index)
            {
                case 0:
                    return true;
                case 1:
                    return false;
                case 2:
                    return false;

            }
        };



        GetDebuggerProperties()
        {
            return [
            {
                title: "CheckInternetAccess",
                properties: [
                    //{name: ".current-animation",	value: this._currentAnimation.GetName(),	onedit: v => this.CallAction(Acts.SetAnim, v, 0) },
                ]
            }];
        }

        // timeline support
        GetPropertyValueByIndex(index)
        {
            return 0;
        }

        SetPropertyValueByIndex(index, value)
        {
            //set property value here
        }
    };
}